image: python:latest

stages:
  - build
  - unit-test
  - deploy


# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# Pip's cache doesn't store the python packages
# https://pip.pypa.io/en/stable/reference/pip_install/#caching
#
# If you want to also cache the installed packages, you have to install
# them in a virtualenv and cache it as well.
cache:
  paths:
    - .cache/pip
    - venv/

before_script:
  - python -V  # Print out python version for debugging
  - pip install virtualenv
  - virtualenv venv
  - source venv/bin/activate

run:
  stage: build
  script:
    - python main.py

# Run all unit tests within the root directory
unit-test:
  stage: unit-test
  script:
    - pip install nose
    - nosetests

deploy:
  stage: deploy
  script:
    - echo "TODO"
  when: manual
